
#include <cstdio>


class Date {
private:

int day; // giorno
int month; // mese
int year; // anno

int julianDay(Date d)
{
 int a, y, m;

 a = (14-d.getMonth())/12;
 y = d.getYear()+4800-a;
 m = d.getMonth()+12*a-3;
 return d.getDay() + (153*m+2)/5+365*y + y/4 - y/100 + y/400 - 32045;
}

public:

Date(void) {day = 1; month = 1; year = 2000;}
int getDay(void) {return day;}
int getMonth(void) {return month;}
int getYear(void) {return year;}

void setDate(int d, int m, int y)
{
 if (y<1 || m<1 || m>12 || d<1) return;
 if ( m==1 || m==3 || m==5 || m==7 || m==8 || m==10 || m==12)
   if (d>31) return;
 if (m==4 || m==6 || m==9 || m==11)
   if (d>30) return;
 if (m==2 && y%4==0) // bisestile
   if (d>29) return;
 if (m==2 && y%4!=0) // non bisestile
   if (d>28) return;
 year = y;
 month = m;
 day = d;
}

int diff(Date d) {
 int my_jd, jd;

 my_jd = julianDay(*this);
 jd = julianDay(d);
 return (jd - my_jd);
}
};


class AdvancedDate : public Date {

private:

static int easterNumber(int y)
{
 int g, c, x, z, d, e, n;
 
 g = y%19+1;
 c = y/100+1;
 x = 3*c/4-12;
 z = (8*c+5)/25-5;
 d = 5*y/4-x-10;
 e = (11*g+20+z-x)%30;
 if (( (e == 25) && (g > 11)) || (e == 24)) e++;
   n = 44-e;
 if (n < 21) n += 30;
   n = n+7-(d+n)%7;
 return n;
}

public:

static void easter(int year, int *day, int *month)
{
 int n = easterNumber(year);

 if (n>31)
   {
    *day=n-31; *month=4; // Aprile
   }
 else
     {
      *day=n; *month=3; // Marzo
     }
}
};


int main(void)
{
 int giorno, mese, anno;

 printf("Anno? ");
 scanf("%i",&anno);

 AdvancedDate::easter(anno, &giorno, &mese);
 printf("Pasqua: %i/%i\r\n", giorno, mese);
}
