
#include <cstring>
#include <cstdio>


class Container
{
 private:

 int codice;
 char descrizione[100];

 public:
 
 Container(void)
 {
  codice = 0;
  strcpy(descrizione, "");
 }

 Container(int _codice, char _descrizione[])
 {
  codice = _codice;
  strcpy(descrizione, _descrizione);
 }

 int getCodice(void) { return codice; }
 void getDescrizione(char* _descrizione) { strcpy(_descrizione, descrizione); }
};


class Piazzola
{
 private:
 
 int numero_container;
 Container pila[5];

 public:

 Piazzola(void)
 {
  numero_container = 0;
 }

 int getNumeroContainer(void) { return numero_container; }

 bool pushContainer(Container container)
 {
  if (numero_container >= 5)
    return false;
  pila[numero_container] = container;
  numero_container++;
  return true;
 }

 Container popContainer(void)
 {
  Container container;

  if (numero_container == 0)
    {
	 // container invalido
	 return container;
    }
  numero_container--;
  return pila[numero_container];
 }

 bool isContainerPresent(int codice_container)
 {
  for (int i=0; i<numero_container; i++)
     if (pila[i].getCodice() == codice_container)
	   return true;
  return false;
 }
};


class Deposito
{
 private:

 int numero_piazzole;
 Piazzola* piazzole;

 public:

 Deposito(int _numero_piazzole)
 {
  numero_piazzole = _numero_piazzole;
  piazzole = new Piazzola[numero_piazzole];
 }

 ~Deposito(void)
 {
  delete piazzole;
 }

 int getNumeroContainer(void)
 {
  int i, n = 0;

  for (i=0; i<numero_piazzole; i++)
     n += piazzole[i].getNumeroContainer();
 
  return n;
 }

 bool addContainer(Container container, int piazzola)
 {
  if (piazzola > numero_piazzole || piazzola<= 0)
    return false;
  
  return piazzole[piazzola-1].pushContainer(container);
 }

 Container getContainer(int piazzola)
 {
  Container container;
 
  if (piazzola > numero_piazzole || piazzola<= 0)
    return container; // container invalido
  return piazzole[piazzola-1].popContainer();
 }

 int findPiazzola(void)
 {
  for (int i=0; i<numero_piazzole; i++)
     if (piazzole[i].getNumeroContainer() < 5)
	   return i+1;
  return 0; // piazzola invalida
 }

 int findPiazzola(int codice_container)
 {
  for (int i=0; i<numero_piazzole; i++)
     if (piazzole[i].isContainerPresent(codice_container))
	   return i+1;
  return 0; // piazzola invalida
 }
};


int main(void)
{
 int piazzola;
 Deposito deposito = Deposito(10);
 Container container;
 char descrizione[100];

 container = Container(1, "Uno");
 deposito.addContainer(container, 1);
 container = Container(2, "Due");
 deposito.addContainer(container, 1);
 container = Container(3, "Tre");
 deposito.addContainer(container, 1);
 container = Container(4, "Quattro");
 deposito.addContainer(container, 1);
 container = Container(5, "Cinque");
 deposito.addContainer(container, 1);
 container = Container(6, "Sei");
 piazzola = deposito.findPiazzola();
 if (piazzola>0)
   deposito.addContainer(container, piazzola);
 printf("Nel deposito sono presenti %i container\r\n", deposito.getNumeroContainer());
 if ((piazzola = deposito.findPiazzola(6)))
   {
	container = deposito.getContainer(piazzola);
	container.getDescrizione(descrizione);
	printf("%i %s\r\n",container.getCodice(), descrizione);
   }
 printf("Nel deposito sono presenti %i container\r\n", deposito.getNumeroContainer());
}




