
#include <cstring>

class Time {

private:

int hour; // ore
int minute; // minuti
int second; // secondi

public:

Time(void) {hour = 0; minute = 0; second = 0;}

Time(int h, int m, int s)
{
 if (h>=0 && h<=23) hour = h;
 else hour = 0;
 if (m>=0 && m<=59) minute = m;
 else minute = 0;
 if (s>=0 && s<=59) second = s;
 else second = 0;
}

int getHour(void) {return hour;}
int getMinute(void) {return minute;}
int getSecond(void) {return second;}
void setHour(int h) {if (h>=0 && h<=23) hour = h;}
void setMinute(int m) {if (m>=0 && m<=59) minute = m;}
void setSecond(int s) {if (s>=0 && s<=59) second = s;}
};


class Date {

private:

int day; // giorno
int month; // mese
int year; // anno

int julianDay(Date d)
{
 int a, y, m;

 a = (14-d.getMonth())/12;
 y = d.getYear()+4800-a;
 m = d.getMonth()+12*a-3;
 return d.getDay() + (153*m+2)/5+365*y + y/4 - y/100 + y/400 - 32045;
}

public:

Date(void) {day = 1; month = 1; year = 2000;}
int getDay(void) {return day;}
int getMonth(void) {return month;}
int getYear(void) {return year;}

void setDate(int d, int m, int y)
{
 if (y<1 || m<1 || m>12 || d<1) return;
 if ( m==1 || m==3 || m==5 || m==7 || m==8 || m==10 || m==12)
   if (d>31) return;
 if (m==4 || m==6 || m==9 || m==11)
   if (d>30) return;
 if (m==2 && y%4==0) // bisestile
   if (d>29) return;
 if (m==2 && y%4!=0) // non bisestile
   if (d>28) return;
 year = y;
 month = m;
 day = d;
}

int diff(Date d) {
 int my_jd, jd;

 my_jd = julianDay(*this);
 jd = julianDay(d);
 return (jd - my_jd);
}
};

class Message {

private:

Date date;
Time time;
bool received;
char message[1024];
static int counter; // attributo statico

public:

Message(void)
{
 strcpy(message,"");
 received = false;
 // incremento per ogni oggetto
 counter++;
}

Date getDate(void) {return date;}
Time getTime(void) {return time;}
bool isReceived(void) {return received;}

int getText(char t[])
{
 strcpy(t, message);
 return strlen(t);
}

void setDate(Date d) {date = d;}
void setTime(Time t) {time = t;}
void setReceived(bool r) {received = r;}
void setText(char t[]) {strcpy(message, t);}

// metodo statico per accesso ad atributo statico
static int getCounter(void) {return counter;}
};

int Message::counter = 0; // inizializzazione attributo statico
