
#include <cstring>
#include <cstdio>

class Barca
{
 private:

 char nome[32];
 char nazione[16];
 float lunghezza;
 float stazza;
 bool vela;

 public:

 Barca(void)
 {
  strcpy(nome, "");
  strcpy(nazione, "???");
  lunghezza = 0;
  stazza = 0;
  vela = false;
 }

 Barca (char _nome[], char _nazione[], float _lunghezza, float _stazza, bool _vela)
 {
  strcpy(nome, _nome);
  strcpy(nazione, _nazione);
  lunghezza = _lunghezza;
  stazza = _stazza;
  vela = _vela;
 }

 void getNome(char* _nome) { strcpy(_nome, nome); }
 void getNazione(char* _nazione) { strcpy(_nazione, nazione); }
 float getLunghezza(void) { return lunghezza; }
 float getStazza(void) { return stazza; }
 bool isVela(void) { return vela; }
};


class Porto
{
 private:

 bool occupato[100];
 Barca barche[100];
 static const float TARIFFA_VELA;
 static const float TARIFFA_MOTORE;

 public:

 Porto(void)
 {
  for (int posto=0; posto<100; posto++)
     occupato[posto] = false;
 }

 int arrivo(Barca barca)
 {
  if (barca.isVela())
    {
	 for (int posto=51; posto<=100; posto++)
	    if (!occupato[posto-1])
		  {
		   barche[posto-1] = barca;
		   occupato[posto-1] = true;
		   return posto;
		  }
	 return -1; // nessun posto libero per barche a vela
    }
  else
      {
	   if (barca.getLunghezza() < 10)
	     for (int posto=1; posto<=20; posto++)
		    if (!occupato[posto-1])
			  {
			   barche[posto-1] = barca;
			   occupato[posto-1] = true;
			   return posto;
			  }
		 for (int posto=21; posto<=100; posto++)
		    if (!occupato[posto-1])
		      {
		       barche[posto-1] = barca;
		       occupato[posto-1] = true;
		       return posto;
		      }
		return -1; // nessun posto libero
      }
 }

 float partenza(int posto, int giorni)
 {
  if (posto<=0 || posto>= 100)
    return 0;

  if (!occupato[posto-1])
    return 0;
  
  occupato[posto-1] = false;

  if (barche[posto-1].isVela())
    return giorni*TARIFFA_VELA*barche[posto-1].getLunghezza();
  else
	  return giorni*TARIFFA_MOTORE*barche[posto-1].getStazza();
 }

 Barca informazioni(int posto)
 {
  Barca barca; // imbarcazione inavlida

  if (posto<=0 || posto>= 100)
    return barca;

  if (!occupato[posto-1])
    return barca;

  return barche[posto-1];
 }

 int cerca(float minimo, float massimo, Barca imbarcazioni[])
 {
  int numero = 0;

  for (int posto=1; posto<=100; posto++)
     if (occupato[posto-1])
	   if (barche[posto-1].getLunghezza() >= minimo && barche[posto-1].getLunghezza() <= massimo)
	     {
		  imbarcazioni[numero] = barche[posto-1];
		  numero++;
	     }
 return numero;
 }
};

const float Porto::TARIFFA_VELA = 10; // per metro al giorno
const float Porto::TARIFFA_MOTORE = 20; // per tonnellata al giorno




int main(void)
{
 Porto porto;
 Barca barca, barche[100];
 int scelta;
 char nome[32];
 char nazione[16];
 float lunghezza, stazza;
 char tipo;
 int posto, giorni;
 float importo;
 float minimo, massimo;
 int i, n;

 do {
     printf("1 => arrivo Vela\r\n");
	 printf("2 => arrivo Motore\r\n");
	 printf("3 => Partenza\r\n");
	 printf("4 => Informazioni\r\n");
	 printf("5 => Cerca\r\n");
	 printf("0 => Fine\r\n");
	 scanf("%i", &scelta);
	 switch (scelta)
	       {
			case 1:		printf("Nome? "); scanf("%s", nome);
						printf("Nazione? "); scanf("%s", nazione);
						printf("Lunghezza? "); scanf("%f", &lunghezza);
						printf("Stazza? "); scanf("%f", &stazza);
						barca = Barca(nome, nazione, lunghezza, stazza, true);
						if ((posto = porto.arrivo(barca)) < 0)
						  printf("Nessun posto disponibile!\r\n");
						else
							printf("Assegnato posto %i\r\n", posto);
						break;
			case 2:		printf("Nome? "); scanf("%s", nome);
						printf("Nazione? "); scanf("%s", nazione);
						printf("Lunghezza? "); scanf("%f", &lunghezza);
						printf("Stazza? "); scanf("%f", &stazza);
						barca = Barca(nome, nazione, lunghezza, stazza, false);
						if ((posto = porto.arrivo(barca)) < 0)
						  printf("Nessun posto disponibile!\r\n");
						else
							printf("Assegnato posto %i\r\n", posto);
						break;
			case 3:		printf("Posto? "); scanf("%i", &posto);
						printf("Giorni? "); scanf("%i", &giorni);
						if ((importo = porto.partenza(posto, giorni)) == 0)
						  printf("Posto errato!\r\n");
						else
							printf("Importo: %f\r\n", importo);
						break;
			case 4:		printf("Posto? "); scanf("%i", &posto);
						barca = porto.informazioni(posto);
						if (barca.getLunghezza() == 0)
						  printf("Posto errato!\r\n");
						else
						    {
							 barca.getNome(nome);
							 barca.getNazione(nazione);
							 lunghezza = barca.getLunghezza();
							 stazza = barca.getStazza();
							 tipo = barca.isVela() ? 'V' : 'M';
							 printf("%s %s %f %f %c\r\n", nome, nazione, lunghezza, stazza, tipo);
						    }
						break;
			case 5:		printf("Lunghezza minima? "); scanf ("%f", &minimo);
						printf("Lunghezza massima? "); scanf("%f", &massimo);
						n = porto.cerca(minimo, massimo, barche);
						for (i=0; i<n; i++)
						   {
							barche[i].getNome(nome);
							barche[i].getNazione(nazione);
							lunghezza = barche[i].getLunghezza();
							stazza = barche[i].getStazza();
							tipo = barche[i].isVela() ? 'V' : 'M';
							printf("%s %s %f %f %c\r\n", nome, nazione, lunghezza, stazza, tipo);
						   }
						break;
			default:
			case 0:		break;
	       }
    } while (scelta!=0);
}


