
#include <cstring>
#include <cstdio>

class Vagone
{
 protected:

 int codice;
 char costruttore[32];
 float peso_vuoto;
 int anno;

 public:

 Vagone(void)
 {
  codice = 0;
  strcpy(costruttore, "");
  peso_vuoto = 0;
  anno = 1900;
 }

 Vagone(int _codice, char _costruttore[], float _peso_vuoto, int _anno)
 {
  codice = _codice;
  strcpy(costruttore, _costruttore);
  peso_vuoto = _peso_vuoto;
  anno = _anno;
 }

 int getCodice(void) { return codice; }
 void getCostruttore(char* _costruttore) { strcpy(_costruttore, costruttore); }
 float getPesoVuoto(void) { return peso_vuoto; }
 int getAnno(void) { return anno; }
};

class Merci : public Vagone
{
 private:

 float volume_carico;
 float carico_massimo;
 float carico_effettivo;

 public:

 Merci(void)
 {
  volume_carico = 0;
  carico_massimo = 0;
  carico_effettivo = 0;
 }

 Merci(int _codice, char _costruttore[], float _peso_vuoto, int _anno, float _volume_carico, float _carico_massimo)
 {
  codice = _codice;
  strcpy(costruttore, _costruttore);
  peso_vuoto = _peso_vuoto;
  anno = _anno;
  volume_carico = _volume_carico;
  carico_massimo = _carico_massimo;
  carico_effettivo = 0;
 }

 float getVolumeCarico(void) { return volume_carico; }
 float getCaricoMassimo(void) { return carico_massimo; }
 float getCaricoEffettivo(void) { return carico_effettivo; }
 void setCaricoEffettivo(float carico) { carico_effettivo = carico; }
 float getPesoTotale(void) { return (peso_vuoto+carico_effettivo); }
};

class Passeggeri : public Vagone
{
 private:

 int classe;
 int posti_totali;
 int posti_occupati;
 static const float PESO_MEDIO_PASSEGGERO;

 public:

 Passeggeri(void)
 {
  classe = 0;
  posti_totali = 0;
  posti_occupati = 0;
 }

 Passeggeri(int _codice, char _costruttore[], float _peso_vuoto, int _anno, int _classe, int _posti_totali)
 {
  codice = _codice;
  strcpy(costruttore, _costruttore);
  peso_vuoto = _peso_vuoto;
  anno = _anno;
  classe = _classe;
  posti_totali = _posti_totali;
  posti_occupati = 0;
 }

 int getClasse(void) { return classe; }
 int getPostiTotali(void) { return posti_totali; }
 int getPostiOccupati(void) { return posti_occupati; }
 void setPostiOccupati(int posti) { posti_occupati = posti; }
 float getPesoTotale(void) { return (peso_vuoto+posti_occupati*PESO_MEDIO_PASSEGGERO); }
};

const float Passeggeri::PESO_MEDIO_PASSEGGERO = 0.065;




int main(void)
{
 Merci treno_merci[2];
 Passeggeri treno_passeggeri[3];
 float peso_merci=0, peso_passeggeri=0;

 // composizione treni
 treno_merci[0] = Merci(123, "Ansaldo", 25, 2001, 90, 50);
 treno_merci[1] = Merci(456, "Ansaldo", 25, 2002, 90, 50);
 treno_passeggeri[0] = Passeggeri(123, "Breda", 30, 2010, 1, 100);
 treno_passeggeri[1] = Passeggeri(456, "Breda", 30, 2011, 2, 120);
 treno_passeggeri[2] = Passeggeri(789, "Breda", 30, 2011, 2, 120);

 // carico treni
 treno_merci[0].setCaricoEffettivo(40);
 treno_merci[1].setCaricoEffettivo(45);
 treno_passeggeri[0].setPostiOccupati(50);
 treno_passeggeri[1].setPostiOccupati(100);
 treno_passeggeri[2].setPostiOccupati(90);

 // peso complessivo vagoni treni
 for (int vagone=0; vagone<2; vagone++)
    peso_merci += treno_merci[vagone].getPesoTotale();
 printf("Peso totale vagoni treno merci: %f tonnellate\r\n", peso_merci);
 for (int vagone=0; vagone<3; vagone++)
    peso_passeggeri += treno_passeggeri[vagone].getPesoTotale();
 printf("Peso totale vagoni treno passeggeri: %f tonnellate\r\n", peso_passeggeri);
}
