
#include <cstdio>

#include "Frigorifero.h"



	 Frigorifero::Frigorifero(unsigned short numero_massimo_prodotti)
	 {
		 this->numero_massimo_prodotti = numero_massimo_prodotti;
		 numero_prodotti = 0;
		 prodotti = new Prodotto[numero_massimo_prodotti];
	 }

	 Frigorifero::~Frigorifero(void)
	 {
		delete[] prodotti;
	 }

	 void Frigorifero::salvaProdotti(void)
	 {
		FILE* file = fopen("frigorifero.bin", "wb");
		RECORD record;
		char descrizione[128];

		for (unsigned short contatore_prodotti = 0; contatore_prodotti < numero_prodotti; contatore_prodotti++)
		{
			record.codice = prodotti[contatore_prodotti].getCodice();
			record.scadenza = prodotti[contatore_prodotti].getScadenza();
			record.calorie = prodotti[contatore_prodotti].getCalorie();
			prodotti[contatore_prodotti].getDescrizione(descrizione);
			strcpy(record.descrizione, descrizione);
			fwrite(&record, sizeof(record), 1, file);
		}
		fclose(file);
	 }

	 void Frigorifero::caricaProdotti(void)
	 {
		FILE* file = fopen("frigorifero.bin", "rb");
		RECORD record;
		char descrizione[128];
		
		numero_prodotti = 0;
		if (file != NULL)
		{
			do
			{
				if (fread(&record, sizeof(RECORD), 1, file) > 0)
				{
					Prodotto prodotto = Prodotto(record.codice, record.descrizione, record.scadenza, record.calorie);
					prodotti[numero_prodotti] = prodotto;
					numero_prodotti++;
					if (numero_prodotti >= numero_massimo_prodotti)
						break;
				}
			} while (!feof(file));
		}
		fclose(file);
	 }
	 
	 bool Frigorifero::inserisciProdotto(Prodotto prodotto)
	 {
		 if (numero_prodotti >= numero_massimo_prodotti)
			 return false;
		 prodotti[numero_prodotti] = prodotto;
		 numero_prodotti++;
		 return true;
	 }


	 bool Frigorifero::estraiProdotto(unsigned long long codice, DATE scadenza, Prodotto* prodotto)
	 {
		 for (unsigned int indice_prodotto = 0; indice_prodotto < numero_prodotti; indice_prodotto++)
			 if (prodotti[indice_prodotto].getCodice() == codice && prodotti[indice_prodotto].getScadenza().anno == scadenza.anno && prodotti[indice_prodotto].getScadenza().mese == scadenza.mese && prodotti[indice_prodotto].getScadenza().giorno == scadenza.giorno)
			 {
				 *prodotto = prodotti[indice_prodotto];
				 for (unsigned int indice = indice_prodotto; indice < numero_prodotti - 1; indice++)
					 prodotti[indice] = prodotti[indice + 1];
				 numero_prodotti--;
				 return true;
			 }
		 return false;
	 }

	 unsigned int Frigorifero::elencoProdotti(Prodotto elenco[])
	 {
		 for (unsigned int indice_prodotto = 0; indice_prodotto < numero_prodotti; indice_prodotto++)
			 elenco[indice_prodotto] = prodotti[indice_prodotto];
		 return numero_prodotti;
	 }

	 unsigned int Frigorifero::elencoProdottiScaduti(DATE data, Prodotto elenco[])
	 {
		 unsigned int indice = 0;

		 for (unsigned int indice_prodotto = 0; indice_prodotto < numero_prodotti; indice_prodotto++)
			 if (prodotti[indice_prodotto].scaduto(data))
			 {
				 elenco[indice] = prodotti[indice_prodotto];
				 indice++;
			 }
		 return indice;
	 }
	 
	 unsigned int Frigorifero::quantitaProdotto(unsigned long long codice)
	 {
		 unsigned int quantita_prodotto = 0;

		 for (unsigned int indice_prodotto = 0; indice_prodotto < numero_prodotti; indice_prodotto++)
			 if (prodotti[indice_prodotto].getCodice() == codice)
				 quantita_prodotto++;
		 return quantita_prodotto;
	 }

